%define name skey
%define version 1.1.5
%define release 2mdk


Summary: S/Key suite of programs
Name: %name
Version: %version
Release: %release
License: BSD
Group: System/Libraries
Source: %name-%version.tar.bz2
Patch0: skey-shadow-password.patch.bz2
URL: ftp://thumper.bellcore.com/pub/nmh/
BuildRoot: %_tmppath/%name-%version-buildroot

%description

This is an S/Key implementation ported from OpenBSD.

S/Key provides One Time Password functionality, and can be
used to increase system security.

%package devel
Summary:	Header files for S/Key
Group:		Development/Other
PreReq:		%name = %version-%release

%description devel

This package contains header files for the S/Key library.

%package static-devel
Summary:	Static libraries for S/Key
Group:		Development/Other
PreReq:		%name-devel = %version-%release

%description static-devel

This package contains the S/Key static library.

%prep
%setup -q

%patch0 -p1 -b .shadow

%build

CFLAGS="$RPM_OPT_FLAGS" \
    ./configure \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--libdir=%{_libdir}
make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall sysconfdir=$RPM_BUILD_ROOT/%{_sysconfdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files

%defattr(-,root,root)

%doc CHANGES INSTALL README
%{_mandir}/*/*
%config(noreplace) %{_sysconfdir}/%{name}/skeykeys
%{_bindir}/skey
%{_bindir}/skeyprune

%defattr(4755,root,root)

%{_bindir}/skeyinit
%{_bindir}/skeyinfo
%{_bindir}/skeyaudit

%files devel

%defattr(-,root,root)

%{_includedir}/*

%files static-devel

%defattr(-,root,root)

%{_libdir}/libskey.a

%changelog
* Wed May 07 2003 Buchan Milne <bgmilne@linux-mandrake.com> 1.1.5-2mdk
- Spec cleanups
- RPM submitted by Marco Slaviero <mslaviero@cs.up.ac.za>
  - Patch to support shadow passwords.
  - Cleaned up spec file, split package into 3.
  - Now devel and static-devel are separate.
